(* a movie is a tuple of (title, studio, gross in millions, year) *)
type movie = string * string * float * int

(* a studio_gross is a pair of (studio, gross in millions) *)
type studio_gross = string * float

(* Data *)
(* Average gross of 377.85*)
let data1 : movie list = [
  ("The Lord of the Rings: The Return of the King","NL",377.85,2003)
]
(* Average gross of 376.085*)
let data2 : movie list = [
  ("The Lord of the Rings: The Return of the King","NL",377.85,2003);
  ("The Hunger Games","LGF",374.32,2012)
]
(* Average gross of 312.519489*)
let data3 : movie list = [
  ("Harry Potter and the Sorcerer's Stone","WB",317.57555,2001);
  ("Star Wars: Episode II - Attack of the Clones","Fox",310.67674,2002);
  ("Return of the Jedi", "Fox", 309.306177, 1983)
]
let data3' : movie list = [
  ("Star Wars: Episode II - Attack of the Clones","Fox",310.67674,2002);
  ("Harry Potter and the Sorcerer's Stone","WB",317.57555,2001);
  ("Return of the Jedi", "Fox", 309.306177, 1983)
]

let data3'' : movie list = [
  ("Star Wars: Episode II - Attack of the Clones","Fox",310.67674,2002);
  ("Return of the Jedi", "Fox", 309.306177, 1983);
  ("Harry Potter and the Sorcerer's Stone","WB",317.57555,2001);
]
(* Average gross of 416.63*)
let data4 : movie list = [
  ("The Lord of the Rings: The Return of the King","NL",377.85,2003);
  ("The Hunger Games","LGF",374.32,2012);
  ("The Dark Knight","WB",533.34,2008);
  ("Harry Potter and the Deathly Hallows Part 2","WB",381.01,2011)
]

let data4' : movie list = [
  ("Harry Potter and the Deathly Hallows Part 2","WB",381.01,2011);
  ("The Lord of the Rings: The Return of the King","NL",377.85,2003);
  ("The Hunger Games","LGF",374.32,2012);
  ("The Dark Knight","WB",533.34,2008);
]

let data5 : movie list = [
  ("The Dark Knight","WB",533.34,2008);
  ("Harry Potter and the Deathly Hallows Part 2","WB",381.01,2011)
]
  
let data6 : movie list = [
  ("Movie A1","Studio A",1.,2000);
  ("Movie B1","Studio B",2.,2001);
  ("Movie A2","Studio A",3.,2003);
  ("Movie A3","Studio A",4.,2004);
  ("Movie C1","Studio C",5.,2002);
  ("Movie C2","Studio C",6.,2005);
  ("Movie B2","Studio B",7.,2006)
]

(* Testing decade *)
let decade10from2 : movie list = [
  ("The Hunger Games","LGF",374.32,2012)
]

let decade00from3 : movie list = [
  ("Harry Potter and the Sorcerer's Stone","WB",317.57555,2001);
  ("Star Wars: Episode II - Attack of the Clones","Fox",310.67674,2002);
]

let decade00from3r : movie list = [
  ("Star Wars: Episode II - Attack of the Clones","Fox",310.67674,2002);
  ("Harry Potter and the Sorcerer's Stone","WB",317.57555,2001);
]

let decade00from4 : movie list = [
  ("The Lord of the Rings: The Return of the King","NL",377.85,2003);
  ("The Dark Knight","WB",533.34,2008);
]

let decade00from4r : movie list = [
  ("The Dark Knight","WB",533.34,2008);
  ("The Lord of the Rings: The Return of the King","NL",377.85,2003);
]

let decade10from4 : movie list = [
  ("The Hunger Games","LGF",374.32,2012);
  ("Harry Potter and the Deathly Hallows Part 2","WB",381.01,2011)
]

let decade10from4r : movie list = [
  ("Harry Potter and the Deathly Hallows Part 2","WB",381.01,2011);
  ("The Hunger Games","LGF",374.32,2012)
]

let dataFuture : movie list = [
  ("Space Emperor Garx","WB",1001.01,2711);
  ("SpiderMan LXXIV","LGF",222.22,2222)
]

(* Testing drop *)
let drop1from4 : movie list = [
  ("The Hunger Games","LGF",374.32,2012);
  ("The Dark Knight","WB",533.34,2008);
  ("Harry Potter and the Deathly Hallows Part 2","WB",381.01,2011)
]

let drop2from4 : movie list = [
  ("The Dark Knight","WB",533.34,2008);
  ("Harry Potter and the Deathly Hallows Part 2","WB",381.01,2011)
]

let drop3from4 : movie list = [
  ("Harry Potter and the Deathly Hallows Part 2","WB",381.01,2011)
]

(* Testing selection_sort *)
let data2byTitle : movie list = [
  ("The Lord of the Rings: The Return of the King","NL",377.85,2003);
  ("The Hunger Games","LGF",374.32,2012)
]

let data2byGross : movie list = [
  ("The Lord of the Rings: The Return of the King","NL",377.85,2003);
  ("The Hunger Games","LGF",374.32,2012)
]

let data2byYear : movie list = [
  ("The Hunger Games","LGF",374.32,2012);
  ("The Lord of the Rings: The Return of the King","NL",377.85,2003)
]

let data3byGross : movie list = [
  ("Harry Potter and the Sorcerer's Stone","WB",317.57555,2001);
  ("Star Wars: Episode II - Attack of the Clones","Fox",310.67674,2002);
  ("Return of the Jedi", "Fox", 309.306177, 1983)
]

let data3byTitle : movie list = [
  ("Star Wars: Episode II - Attack of the Clones","Fox",310.67674,2002);
  ("Return of the Jedi", "Fox", 309.306177, 1983);
  ("Harry Potter and the Sorcerer's Stone","WB",317.57555,2001)
]

let data3byYear : movie list = [
  ("Star Wars: Episode II - Attack of the Clones","Fox",310.67674,2002);
  ("Harry Potter and the Sorcerer's Stone","WB",317.57555,2001);
  ("Return of the Jedi", "Fox", 309.306177, 1983)
]

let data4byTitle : movie list = [  
  ("The Lord of the Rings: The Return of the King","NL",377.85,2003);
  ("The Hunger Games","LGF",374.32,2012);
  ("The Dark Knight","WB",533.34,2008);  
  ("Harry Potter and the Deathly Hallows Part 2","WB",381.01,2011)
]
let data4byGross : movie list = [
  ("The Dark Knight","WB",533.34,2008);
  ("Harry Potter and the Deathly Hallows Part 2","WB",381.01,2011);
  ("The Lord of the Rings: The Return of the King","NL",377.85,2003);
  ("The Hunger Games","LGF",374.32,2012)
]
let data4byYear : movie list = [
  ("The Hunger Games","LGF",374.32,2012);
  ("Harry Potter and the Deathly Hallows Part 2","WB",381.01,2011);
  ("The Dark Knight","WB",533.34,2008);
  ("The Lord of the Rings: The Return of the King","NL",377.85,2003)
]

let s1 = ("S1", 123.4)
let s2 = ("S2", 234.5)
let s3 = ("S3", 345.6)
let sOrdered = [s3;s2;s1]

(*Sorted by Studio*)
let bs1 = [("NL", 377.85)]
let bs2 = [("LGF", 374.32);("NL", 377.85)]
let bs5 = [("WB",914.35)]
let bs3 = [("Fox",619.982917) ; ("WB",317.57555)]
let bs4 = [("LGF", 374.32); ("NL", 377.85) ; ("WB",914.35) ]
let bs6 = [("Studio A",8.);("Studio B", 9.);("Studio C", 11.)]
