(*************)
(* PROBLEM 1 *)
(*************)

(* For each part of problem 1, explain in the given string why the code
   will not typecheck, then follow the instructions for that part to
   change the code so that it typechecks while keeping the same values
   as intended by the erroneous code. Once you have done so, uncomment
   the fixed expression for submission.
*)

(* Problem 1a - Give your explanation in exp1a and then fix the
   right-hand-side of the assignment to match the listed type. 
   (Do not change the left-hand-side.)
*)

(*
let exp1a : string = ""
let prob1a : int list = [1, 2, 3]
*)

(* Problem 1b - Give your explanation in exp1b and then fix the type
   of variable prob1b to match the type of the expression on the
   right-hand-side of the assignment. (Do not change the
   right-hand-side.)
 *)

(*
let exp1b : string = ""
let prob1b : string * int list = [("COS", 326); ("COS", 441)]
*)

(* Problem 1c - Give your explanation in exp1c and then fix the
   right-hand-side of the expression to match the variable prob1c's
   listed type. 
   (Do not change the left-hand-side.)  
*)

(*
let exp1c : string = ""
let prob1c : float list = [2.0; 3.0] :: [4.0; 5.0]
*)

(*************)
(* PROBLEM 2 *)
(*************)

(* Fill in expressions to satisfy the following types: 
 *
 * NOTE: for option, list, and function types, you must 
 * provide a nontrivial answer. For a list that means a 
 * non-empty one, for an option type that means a Some 
 * construction, and for a function, that means using 
 * its arguments to generate the return value.
 * example problems:
 *   let x : int option = ??? 
 *   let y : int list = ??? 
 *   let f (x: int) (y: int) : int = ??? 
 * incorrect answers:
 *   let x : int option = None 
 *   let y : int list = [] 
 *   let f (x: int) (y: int) : int = 7 
 * possible correct answers:
 *   let x : int option = Some 1 
 *   let y : int list = [1] 
 *   let y : int list = [1; 2] 
 *   let y : int list = 1 :: [2] 
 *   let f (x: int) (y: int) : int = x + y 
 *   let f (x: int) (y: int) : int = 
 *         String.length  ((string_of_int x) ^ (string_of_int y)) 
 *)

(*>* Problem 2a *>*)
(*  
let prob2a : (float * (string * int) option list) list = 
*)

(*>* Problem 2b *>*)
(* a student is a (name, age option) pair *)

type student = string * int option
(*
let prob2b : (student list option * int) list = 
*)


(*>* Problem 2c *>*)
(*
let prob2c : (int * int -> int) * (float -> float -> unit) * bool  = 
*)

(*>* Problem 2d *>*)
(* Fill in a valid function call to foo to make prob2d typecheck *)

(*
let prob2d =
  let rec foo bar =
    match bar with
    | (a, (b, c)) :: xs -> if a then (b + c + (foo xs)) else foo xs
    | _ -> 0
  in 
*)

(*************)
(* PROBLEM 3 *)
(*************)

(* Consider the following terribly written function: *)

let rec zardoz f ls acc =
  if (((List.length (ls@[])) = 1) = true) then (f (List.hd(ls)) (acc))
  else if (((List.length ls) = 0) = true) then acc
  else
    let hd = List.hd(ls) in
        let tl = List.tl(ls) in
      let ans = f (hd) (acc) in
    let ans = zardoz f tl ans in
        ans
  
(* Rewrite the code above so that it does the same thing
 * but style-wise is far superior.  
 * Be sure to provide types for the function's arguments and to 
 * call itself (not the original zardoz) recursively as needed.
 * You may want to write some assert statements
 * to check that your function is doing the same thing as zardoz.  
 * Use the COS 326 style guide. *)

(*
let rec myzardoz f ls acc =
*)


(* Testing functions. You do not need to change these.
 * These function will be used to test problems 4, 5,
 * and 6. Example tests will be provided, but you
 * will need to add additional tests. *)

(* Dummy test functions.  No need to edit these. *)
let problem_4_tests () = ()
let problem_5_tests () = ()
let problem_6_tests () = ()

(* Comparison function for sorting lists *)
let rec comp_list (a: int list)  (b: int list) =
  match (a,b) with
  | (ah::at, bh::bt) -> if ah > bh then 1 else if bh > ah then -1 else comp_list at bt
  | (ah::at, []) -> 1
  | ([], bh::bt) -> -1
  | _ -> 0

(* Print a list of integers *)
let print_list_int (l : int list) =
  print_string "[";
  let rec iter l =
    match l with
      | a::b -> print_string "; "; print_int a; iter b
      | _ -> print_string "]"
  in
  match l with
    | a::b -> print_int a; iter b
    | _ -> print_string "]"

(* Print a list of lists of integers *)
let print_list_list (l : int list list) =
  print_string "[";
  let rec iter l =
    match l with
      | a::b -> print_string "; "; print_list_int a; iter b
      | _ -> print_string "]"
  in
  match l with
    | a::b -> print_list_int a; iter b
    | _ -> print_string "]"

(* Function to run tests. The arguments are your code's output,
 * then the expected output, then a function to print output, then
 * finally the name of the test. Take note that this code does not
 * check for exceptions, so if your code throws an exception it will
 * fail at runtime. *)
let run_test (student_ans:'a) (correct_ans:'a) (print_fun:'a->unit) (test_name:string) = 
  if (student_ans = correct_ans) == false then
    (print_string ("TEST FAILED: "^test_name^"\n");
    print_string "Got: ";
    print_fun student_ans;
    print_string "\nExpected: ";
    print_fun correct_ans;
    print_string "\n";
    ()) 
  else ()

(*************)
(* PROBLEM 4 *)
(*************)

(***************************************)
(* Conway's Lost Cosmological Theorem! *)
(***************************************)

(* 

If l is any list of integers, the look-and-say list of s is obtained by 
reading off adjacent groups of identical elements in s. For example, the 
look-and-say list of

l = [2; 2; 2]

is

[3; 2]

because l is exactly "three twos." Similarly, the look-and-say sequence of

l = [1; 2; 2]

is

[1; 1; 2; 2]

because l is exactly "one ones, then two twos."

You will now define a function look_and_say that computes the 
look-and-say sequence of its argument. look_and_say of an empty 
list is the empty list. 

For full credit your solution should be a linear time solution.

CULTURAL ASIDE:

The title of this problem comes from a theorem about the sequence generated 
by repeated applications of the "look and say" operation. As look and say 
has type int list -> int list, the function can be applied to its own result. 
For example, if we start with the list of length one consisting of just the 
number 1, we get the following first 6 elements of the sequence:

[1]
[1,1]
[2,1]
[1,2,1,1]
[1,1,1,2,2,1]
[3,1,2,2,1,1]

Conway's theorem states that any element of this sequence will "decay" 
(by repeated applications of look and say) into a "compound" made up of 
combinations of "primitive elements" (there are 92 of them, plus 2 
infinite families) in 24 steps. If you are interested in this sequence, 
you may wish to consult [Conway(1987)] or other papers about the 
"look and say" operation.

====== 

Progamming practice aside related to the "look and say" problem. You
may find this useful for constructing your solution to "look and say",
or you may not. 

Another interesting list problem is determining "runs"
in a list: maximal length sublists with all equal elements. For
example,

[1; 1; 1] and [5]

are both runs of the list

[1; 1; 1; 5; 2]

but

[1; 1] and [5; 2] and [1; 2]

are not: 

[1; 1] is not maximal
[5; 2] has unequal elements
[1; 2] is not a sublist.

*)
(*  
let look_and_say (xs: int list) : int list = 
*)


(* Look and Say tests. You should add more to these tests, as
 * the given tests are incomplete. Recall that the run_test
 * function takes a student answer, the expected answer,
 * a print method, and a test name. *)

(*
let problem_4_tests () =
  run_test (look_and_say []) [] print_list_int "[]";
  run_test (look_and_say [1]) [1;1] print_list_int "[1]";
  ()
*)

(*************)
(* PROBLEM 5 *)
(*************)

(* Write a function that flattens a list of lists in to a single
 * list with all of the elements in the same order they appeared in 
 * the original list of lists. eg:
 *
 * flatten [[1;2;3]; []; [4]; [5;6]] = [1;2;3;4;5;6] 
 * flatten [[]; ['e';'d']; ['a';'b';'c']] = ['e';'d';'a';'b';'c'] 
 *)

(*
let rec flatten (xss:'a list list) : 'a list =
*)

(* Flatten tests. You should add more to these tests, as
 * the given tests are incomplete. *)

(*
let problem_5_tests () =
  run_test (flatten [[1];[2];[3]]) [1;2;3] print_list_int "[[1];[2];[3]]";
  ()
*)

(**************************************)
(* PROBLEM 6 -- Warning: challenging! *)
(**************************************)
  
(* Return the list of all permutations of the input list. eg: 
   perm [1;2;3] = [[1;2;3]; [1;3;2]; [2;1;3]; [2;3;1]; [3;1;2]; [3;2;1]] 
   The ordering of the permutations does not matter in your solution.
   We will accept either [[]] or [] as the result for perm [].
   NB: test this on small inputs - perm is ~n! which is approximately ~n^n.
 *)

(*
let perm (items:'a list) : 'a list list =
*)



(* Permutation tests. You should add more to these tests, as
 * the given tests are incomplete. As the lists produced by
 * your function are not requiered to be in a specific order,
 * it is a good idea to sort your lists if they are not in the
 * order a test expects. The provided comparison function can
 * used with List.sort. *)

(*
let problem_6_tests () =
  run_test (List.sort comp_list (perm [1;2])) [[1;2]; [2;1]] print_list_list "[1;2]";
  ()
*)

(* Optional, ungraded, but easy:
   Define the factorial function, then try this: *)
(*
let testperm_length al =
  assert (List.length (perm al) = fac(List.length al))

let _ = testperm_length [1;2;3]   (* etc *)
*)
